#ifndef _LINUX_NFS4_MOUNT_H
#define _LINUX_NFS4_MOUNT_H

/*
 * linux/include/linux/nfs4_mount.h
 * from linux/include/nfs_mount.h
 *     Copyright (C) 1992  Rick Sladkey
 * NFSv4 implementation
 *    Kendrick Smith  <kmsmith@umich.edu>
 *    Andy Adamson  <andros@umich.edu>
 *    Copyright (C) 2001 The Regents of the University of Michigan
 */

#define KERNEL_NFS_MOUNT_VERSION 5
#define NFS4_MOUNT_VERSION	5
#define NFS_MOUNT_VERSION	5
#define NFS_MOUNT_VER4          0x0400  

/*
 * WARNING!  Do not delete or change the order of these fields.  If
 * a new field is required then add it to the end.  The version field
 * tracks which fields are present.  This will ensure some measure of
 * mount-to-kernel version compatibility.  Some of these aren't used yet
 * but here they are anyway.
 */
struct nfs4_mount_data {
	int		version;		/* 1 */
	int		fd;			/* 1 */
	int		flags;			/* 1 */
	int		rsize;			/* 1 */
	int		wsize;			/* 1 */
	int		timeo;			/* 1 */
	int		retrans;		/* 1 */
	int		acregmin;		/* 1 */
	int		acregmax;		/* 1 */
	int		acdirmin;		/* 1 */
	int		acdirmax;		/* 1 */
	struct sockaddr_in addr;		/* 1 */
	char		hostname[256];		/* 1 */
	int		namlen;			/* 2 */
	unsigned int	bsize;			/* 3 */
	char		mnt_path[256];
	char		ipaddr[16];
	int		strict_locking;
	int		silly_rename;
};

/* bits in the flags field */

#define NFS4_MOUNT_SOFT			0x0001	/* 1 */
#define NFS4_MOUNT_INTR			0x0002	/* 1 */
#define NFS4_MOUNT_SECURE		0x0004	/* 1 */
#define NFS4_MOUNT_POSIX		0x0008	/* 1 */
#define NFS4_MOUNT_NOCTO		0x0010	/* 1 */
#define NFS4_MOUNT_NOAC			0x0020	/* 1 */
#define NFS4_MOUNT_TCP			0x0040	/* 2 */
#define NFS4_MOUNT_VER3			0x0080	/* 3 */
#define NFS4_MOUNT_KERBEROS		0x0100	/* 3 */
#define NFS4_MOUNT_NONLM		0x0200	/* 3 */
#define NFS4_MOUNT_BROKEN_SUID		0x0400	/* 4 */
#define NFS4_MOUNT_FLAGMASK		0xFFFF

#endif
